/*

*/

import renderer.scene.*;
import renderer.models.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.io.File;
import java.awt.Color;

/**
   http://merganser.math.gvsu.edu/david/psseminar/index.html#jiggity
*/
public class ThreeDimensionalScene_R5
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Create several Model objects.
      Model m1 = new Cube();
      Model m2 = new Tetrahedron();
      Model m3 = new Octahedron();
      Model m4 = new Dodecahedron();
      Model m5 = new Icosahedron();
      Model m6 = new PanelXZ(-7, 7, -7, 7);

      ModelShading.setColor(Color.red, m1);
      ModelShading.setColor(Color.red, m2);
      ModelShading.setColor(Color.red, m3);
      ModelShading.setColor(Color.red, m4);
      ModelShading.setColor(Color.red, m5);
      ModelShading.setColor(Color.blue, m6);

      // Add the models to the scene.
      scene.addModel(m1, m2, m3, m4, m5, m6);

      // Place each model in the scene in front of the camera.
      for (Vertex v : m6.vertexList) // Panel
      {
         v.x +=  0;
         v.y += -7;
         v.z += -14;
      }
      for (Vertex v : m1.vertexList) // Cube
      {
         v.x += -4;
         v.y +=  0;
         v.z += -18;
      }
      for (Vertex v : m2.vertexList) //Tetrahedron
      {
         v.x +=  0;
         v.y += -2;
         v.z += -14;
      }
      for (Vertex v : m3.vertexList) // Octahedron
      {
         v.x +=  4;
         v.y += -3;
         v.z += -10;
      }
      for (Vertex v : m4.vertexList) // Dodecahedron
      {
         v.x += -4;
         v.y += -3;
         v.z += -10;
      }
      for (Vertex v : m5.vertexList) // Icosahedron
      {
         v.x +=  4;
         v.y +=  0;
         v.z += -18;
      }

      // Create a framebuffer to render our scene into.
      int vp_width  = 1024;
      int vp_height = 1024;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(Color.white);
      // Render
      Pipeline.render(scene, fb.vp);
      fb.dumpFB2File("ThreeDimensionalScene_R5.ppm");
   }
}
